unit Epe01au1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls;

const ver='16 Oct 01';

type
  Tepe01af1 = class(TForm)
    laTitle: TLabel;
    laTitle2: TLabel;
    laTitle3: TLabel;
    laTitle4: TLabel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    ScrollBar3: TScrollBar;
    ScrollBar4: TScrollBar;
    buQuit: TButton;
    laSB1: TLabel;
    laSB2: TLabel;
    laSB3: TLabel;
    laSB4: TLabel;
    buPortOnOff: TButton;
    Label1: TLabel;
    Label2: TLabel;
    laPortOnOff: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Timer1: TTimer;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure buPortOnOffClick(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure ScrollBar4Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    bSB1Inverted,bSB2Inverted,bSB3Inverted,bSB4Inverted:byte;
    (*The scrollbars consider UP to be 0, which is non-
    intuitive, so at a low level, the sb.position is moved
    to a variable which works the other way around.*)
    boTickTock,boHWEnabled:boolean;
    liTmp:longint;
    procedure Send4BytesToExternalDevice;
  public
    { Public declarations }
  end;

var
  epe01af1: Tepe01af1;

implementation

{$R *.DFM}

procedure Tepe01af1.Timer1Timer(Sender: TObject);
begin
boTickTock:=true;
end;

procedure Tepe01af1.Send4BytesToExternalDevice;
(*This whole routine could be written more cleverly... but why bother?*)
  procedure Delay(bTmp2:byte);
  (*More messy-but-should-work code!*)
  begin
  {froze machine...
  boTickTock:=false;
  c1:=0;
  timer1.enabled:=true;
  repeat
  until boTickTock;
  ... and went screwy with app.procmess inside}
  {All sorts of problems with variations of...
  while c1<bTmp do begin
  application.processmessages;
  if boTickTock then begin
     inc(c1);
     boTickTock:=false;
     end;
  end;(*while*)
  timer1.enabled:=false;}
  liTmp:=gettickcount+5;
  repeat
  until gettickcount>liTmp;
  end;

  procedure Prn1(bTmp:byte);
  begin
  port[888]:=bTmp;
  end;

  procedure Prn3(bTmp:byte);
  begin
  port[890]:=bTmp;
  end;

  procedure DoByte1(bTmp:byte);
  (*8 calls of this take care of the byte.*)
  begin
   if (bSB1Inverted and bTmp)=bTmp then Prn1(1) else Prn1(0);
   Prn3(1);
   Delay(2);
   Prn3(3);
   end;

  procedure DoByte2(bTmp:byte);
  (*8 calls of this take care of the byte.*)
  begin
   if (bSB2Inverted and bTmp)=bTmp then Prn1(1) else Prn1(0);
   Prn3(1);
   Delay(2);
   Prn3(3);
   end;

  procedure DoByte3(bTmp:byte);
  (*8 calls of this take care of the byte.*)
  begin
   if (bSB3Inverted and bTmp)=bTmp then Prn1(1) else Prn1(0);
   Prn3(1);
   Delay(2);
   Prn3(3);
   end;

  procedure DoByte4(bTmp:byte);
  (*8 calls of this take care of the byte.*)
  begin
   if (bSB4Inverted and bTmp)=bTmp then Prn1(1) else Prn1(0);
   Prn3(1);
   Delay(2);
   Prn3(3);
   end;

begin  (*Send4BytesToExternalDevice*)
DoByte1(128);
DoByte1(64);
DoByte1(32);
DoByte1(16);
DoByte1(8);
DoByte1(4);
DoByte1(2);
DoByte1(1);

DoByte2(128);
DoByte2(64);
DoByte2(32);
DoByte2(16);
DoByte2(8);
DoByte2(4);
DoByte2(2);
DoByte2(1);

DoByte3(128);
DoByte3(64);
DoByte3(32);
DoByte3(16);
DoByte3(8);
DoByte3(4);
DoByte3(2);
DoByte3(1);

DoByte4(128);
DoByte4(64);
DoByte4(32);
DoByte4(16);
DoByte4(8);
DoByte4(4);
DoByte4(2);
DoByte4(1);

(*And finally, to latch...*)
Prn3(2);
Delay(2);
Prn3(3);       
end;

procedure Tepe01af1.FormCreate(Sender: TObject);
begin
laTitle3.caption:=laTitle3.caption+ver+')';
boHWEnabled:=false;
timer1.enabled:=false;
timer1.interval:=15;
end;

procedure Tepe01af1.buQuitClick(Sender: TObject);
begin
application.terminate;
end;

procedure Tepe01af1.buPortOnOffClick(Sender: TObject);
begin
if boHWEnabled then begin
laPortOnOff.caption:='enable';
buPortOnOff.caption:='Turn Port On';
boHWEnabled:=false;
end (*no ; here*)
else begin
laPortOnOff.caption:='disable';
buPortOnOff.caption:='Turn Port Off';
boHWEnabled:=true;
end;(*else*)
end;

(*I was being lazy!! There MUST be a way to have one "ScrollbarChange"
handler deal with all four scrollbars!!! (And it would be less
susceptible to typos where, say, a "2" appears where a "4" is wanted!*)

procedure Tepe01af1.ScrollBar1Change(Sender: TObject);
begin
bSB1Inverted:=255-ScrollBar1.position;
laSB1.caption:=inttostr(bSB1Inverted);
if boHWEnabled then Send4BytesToExternalDevice;
end;

procedure Tepe01af1.ScrollBar2Change(Sender: TObject);
begin
bSB2Inverted:=255-ScrollBar2.position;
laSB2.caption:=inttostr(bSB2Inverted);
if boHWEnabled then Send4BytesToExternalDevice;
end;

procedure Tepe01af1.ScrollBar3Change(Sender: TObject);
begin
bSB3Inverted:=255-ScrollBar3.position;
laSB3.caption:=inttostr(bSB3Inverted);
if boHWEnabled then Send4BytesToExternalDevice;
end;

procedure Tepe01af1.ScrollBar4Change(Sender: TObject);
begin
bSB4Inverted:=255-ScrollBar4.position;
laSB4.caption:=inttostr(bSB4Inverted);
if boHWEnabled then Send4BytesToExternalDevice;
end;

end.
